#ifndef SCENE_H_
#define SCENE_H_

#include "vector.h"
#include "sprite.h"
#include "object.h"

typedef void (*Scene_func)(struct Scene*);
typedef bool (*Scene_func_add_object)(struct Scene*, struct Object*);
typedef bool (*Scene_func_add_sprite)(struct Scene*, struct Sprite*);
typedef struct Scene {
    char* name;
    Vector* objects;
    Vector* sprites;

    Scene_func_add_object add_object;
    Scene_func_add_sprite add_sprite;
    Scene_func update;
    Scene_func draw;
    Scene_func load;
} Scene;

void free_Scene(struct Scene* self);
Scene* new_Scene(const char* name);
Scene* current_Scene();

#endif
